#include <avr/io.h>
#include <util/delay.h>
#include "lcd.h"

unsigned char curpos = 0;

void lcdcom (unsigned char x)
{
	#if LCDBUS == 'l'
	 x = (x<<4) | (x>>4);
	#endif

	LCDPDAT = x;
	LCDPRS &=~ (1<<LCDRS);
	LCDPEN |= (1<<LCDEN);
	_delay_ms(1);
	LCDPEN &=~ (1<<LCDEN);
	x = (x<<4) | (x>>4);
	LCDPDAT = x;
	LCDPRS &=~ (1<<LCDRS);
	LCDPEN |= (1<<LCDEN);
	_delay_ms(1);
	LCDPEN &=~ (1<<LCDEN);
	LCDPDAT = 0;
	_delay_ms(10);
}



void lcdini (void) 
{
	_delay_ms(250);
	lcdcom(0x33);
	lcdcom(0x32);
	lcdcom(0x28);
	lcdcom(0x0C);
	lcdcom(0x06);
	lcdcom(0x02);
	lcdcom(0x01);
}

void lcdcur (void)
{
	curpos++;
	if (curpos == 0x0F) {
		curpos = 0x40;
		lcdcom(0x80 | 0x40);
		}
	if (curpos == 0x4F) {
		curpos = 0x10;
		lcdcom(0x80 | 0x10);
		}
	if (curpos == 0x1F) {
		curpos = 0x50;
		lcdcom(0x80 | 0x50);
		}
	if (curpos == 0x5F) {
		curpos = 0x00;
		lcdcom(0x80 | 0x00);
		}
}

void lcdput(unsigned char x) 
{
	#if LCDBUS == 'l'
		x = (x<<4) | (x>>4);
	#endif
	LCDPDAT = x;
	LCDPRS |= (1<<LCDRS);
	LCDPEN |= (1<<LCDEN);
	_delay_ms(1);
	LCDPEN &=~ (1<<LCDEN);
	x = (x<<4) | (x>>4);
	LCDPDAT = x;
	LCDPRS |= (1<<LCDRS);
	LCDPEN |= (1<<LCDEN);
	_delay_ms(1);
	LCDPEN &=~ (1<<LCDEN);
	LCDPDAT = 0;
	_delay_ms(10);
}

void lcdputs (const char *zeiger)
{
	while(*zeiger != 0) {
		lcdput(*zeiger++);
		//lcdcur();
		}
}
